C........................................................May 2022
C WU, WL, WE global 1h from JPL monthly median
C t0 at Kp storm peak
C SSN=0, Kp >=3
C........................................................Dec.2020
C Extract Wp, WU, WL and WE -index for -24h<t0< +48h for Kp_1_2 events 
C 
C Select period of 72hrs starting from t0-24h, ending t0+48h; t0 @ Kpmax_hour
C 
      PROGRAM decodkp5WUmj
C Input for 1996-2021 SSN=0 Kp >=3
C add: select from -24h < to <+24h for Kp-events
C
C----------------------------------------------------------------
C
	DIMENSION inpn(0:47) ! 1h indices for 24h (or 72h file for 1h indices)
	+,ind24(0:23),inpn_pre(0:47),wpind(0:23),wnpn(0:47)
C
	CHARACTER*4 AYEAR
      CHARACTER*128 INFILE,INFHSS,txt
	+,outfilpn  !WU, WL, WE, Wp
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	INTEGER kw	  ! kw=1 xx='up', kw=2 xx='ln', kw=3 xx='er', kw=4 xx='wp'
	CHARACTER*2 xx
C//      CHARACTER*1 kpx
C//	CHARACTER*1 gns  ! global, north, south, Wp
C++
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
	infile='d:/web/graf/datm/wxxYRjm.txt' ! 1h 
C
	outfilpn='kwxxjm.txt' !WE total file for 1996-2021 =nev lines x 48 cols superposed epoch	! 3
  	infhss='wulessn0kp3jm.dat'  ! Kp >=3 (SSN=0)
C
C Start 
       kw=1		   !first WU
    1	CONTINUE
      if (kw.eq.1) xx='up'	!first WU
      if (kw.eq.2) xx='ln'	!WL
      if (kw.eq.3) xx='er'	!WE
      if (kw.eq.4) xx='pt'	!Wp
      outfilpn(3:4)=xx  !
      	if (kw.eq.4) goto 7 !Wp
         infile(19:20)=xx
	goto 47
C	Wp index
    7	infile='d:/web/graf/datm/wptecYRjm.txt' ! 1h 
C
   47   OPEN(11,FILE=OUTFILPN)
C
C Kp_1_2 nev storms from 1994 to 2021
C
   28 format(1X,F8.3,3(1X,I2),3(1X,F6.0))
   29 format(1X,F8.3,1X,I3,3(1X,I2),1X,F4.1,3(1X,I3,1X,F6.2),1X,I3
     +,1X,I4)

C
	open(10,file=infhss,action='READ')
C
C Cycle on events ====================================================
C
      lda_pre=16
	iyear_pre=1996
	nev=563
C
	DO 177 iev=1,nev
C      read(10,29,end=27) ryear1,lda1,imn1,idy1,iut1,xkp,ikpsum,ninp
    	read(10,29,end=27) ryear1,lda1,imn1,idy1,iut1,xkp,jtwu,wumax,jtwl
     +,wlmin,jtwe,wemax,ikpsum,ninp
	iutcnt=0
	iyear=int(ryear1)
	iyr=iyear-iyear/100*100
C
      lda0=lda1-1 ! -1d
	lda2=lda1+2
C
C   37 format(20X,24(I4))	 ! AE
   37 format(6X,24(1X,I4))	 !WU, WL, WE
  137 format(6X,24(1X,F4.1))	 ! Wp
C
	if (lda0.eq.0) then  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C read last day of prec. year:
C
	iyear0=iyear-1
       call blet4(iyear0,AYEAR)
	if (kw.eq.4) then
		infile(23:24)=AYEAR(3:4)  ! Wp
	else
	infile(21:22)=AYEAR(3:4)  ! WU, WL,WE
	endif
	open(15,file=infile,action='READ')
	read(15,*) txt ! title line
	ryear0=float(iyear0)
		if(int(ryear0/4.)*4.eq.iyear0) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF

	DO 101 k=1,ndnyr
	      if (kw.eq.4) then
 	read(15,137,end=102) (wpind(ii),ii=0,23)
	 do kk=0,23
	ind24(kk)=int(wpind(kk)*10.0)
	 enddo
	else
	read(15,37,end=102) (ind24(ii),ii=0,23)
	endif

  101	CONTINUE
  102	close(unit=15)
C last day of prec year from iut1 to 23 h:   
       DO ii=iut1,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C
C Prec. day from current year:
       call blet4(iyear,AYEAR)
	if (kw.eq.4) then
		infile(23:24)=AYEAR(3:4)  ! Wp
	else
	infile(21:22)=AYEAR(3:4)  ! WU, WL,WE
	endif
	open(15,file=infile,action='READ')
		read(15,*) txt ! title line
C
	if (lda0.gt.0) then !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	DO 109 k=1,lda0
	      if (kw.eq.4) then
 	read(15,137,end=103) (wpind(ii),ii=0,23)
	 do kk=0,23
	ind24(kk)=int(wpind(kk)*10.0)
	 enddo
	else
	read(15,37,end=104) (ind24(ii),ii=0,23)
	endif
  109	CONTINUE
       DO ii=iut1,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C 1st day from current year:
	      if (kw.eq.4) then
 	read(15,137,end=103) (wpind(ii),ii=0,23)
	 do k=0,23
	ind24(k)=int(wpind(k)*10.0)
	 enddo
	else
	read(15,37,end=103) (ind24(ii),ii=0,23)
	endif
C	  1st day :
       DO ii=0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 2nd day from current year:
	      if (kw.eq.4) then
 	read(15,137,end=103) (wpind(ii),ii=0,23)
	 do k=0,23
	ind24(k)=int(wpind(k)*10.0)
	 enddo
	else
	read(15,37,end=103) (ind24(ii),ii=0,23)
	endif
C	  2nd day :
       DO ii=0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 3rd day from current year:
	      if (kw.eq.4) then
 	read(15,137,end=103) (wpind(ii),ii=0,23)
	 do k=0,23
	ind24(k)=int(wpind(k)*10.0)
	 enddo
	else
	read(15,37,end=103) (ind24(ii),ii=0,23)
	endif
C	  3rd day :
       DO ii=0,23
	if (iutcnt.lt.48) then
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
  103	close(unit=15)
C
C Next year if necessary:
       if (iutcnt.lt.48) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	iyear1=iyear+1
	call blet4(iyear1,AYEAR)
	if (kw.eq.4) then
		infile(23:24)=AYEAR(3:4)  ! Wp
	else
	infile(21:22)=AYEAR(3:4)  ! WU, WL,WE
	endif
	open(15,file=infile,action='READ')
		read(15,*) txt ! title line
C
	      if (kw.eq.4) then
 	read(15,137,end=104) (wpind(ii),ii=0,23)
	 do k=0,23
	ind24(k)=int(wpind(k)*10.0)
	 enddo
	else
	read(15,37,end=104) (ind24(ii),ii=0,23)
	endif
C	  next day :
       DO ii=0,23
	if (iutcnt.lt.48) then
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
      endif	                !>>>>>>>>>>>>>>>>>>>>>
  104	close(unit=15)
C
   38 format(48(1X,I4))
  138 format(48(1X,F4.1))
C Output matrices:
       if (kw.eq.4) then
	do k=0,47
	wnpn(k)=inpn(k)/10.0
	enddo
 	write(*,138) (wnpn(k),k=0,47)
	write(11,138) (wnpn(k),k=0,47)
	 else
 	write(*,38) (inpn(k),k=0,47)
	write(11,38) (inpn(k),k=0,47)
	 endif
	do jk=0,47
	inpn_pre(jk)=inpn(jk)
	enddo
  177	CONTINUE
   27 close(unit=10)
      close(unit=11)
C
      kw=kw+1
        if (kw.lt.5) then
	goto 1
	  endif
C
   35      write(*,*) outfilpn
      pause ' ' 
      STOP
       END

C***********************************************************
